using System;
using System.Collections;
using System.Reflection;
using System.Runtime.Remoting;
using System.Runtime.Remoting.Activation;
using System.Runtime.Remoting.Messaging;
using System.Runtime.Remoting.Contexts;
using System.Runtime.Serialization;
using Kodama.Aop.Aspect;
using Kodama.Aop.Interceptor;
using Kodama.Aop.JoinPoint;
using Kodama.Aop.Pointcut;

namespace Kodama.Aop.Weaver
{
    /// <summary>
    /// AspectWeaveNXł
    /// </summary>
    /// <remarks>
    /// <p>̃NX̓O[oɃCX^X̐ɏs߂
    /// SingletonɂȂĂ܂B</p>
    /// <p>̃NXWeaveAspecto^ƁANXAspect
    /// Weave܂B܂Aɐꂽ̃CX^XAspect
    /// Weave邱Ƃ\łB</p>
    /// <p>ߓIvNVƃbZ[WVN𗘗pĂ邽߁AWeaveΏۂ
    /// ȂIuWFNgContextBoundObjectpĂKv܂B</p>
    /// <p>ӓ_͓ߓIvNVƃX^bNr_[VÑI[o[wbh
    /// \bhĂяoȂǂɂ邱ƂłBptH[}Xvꍇ
    /// AXyNg𗘗pȂ(ContextBoundObjectpAspectAttribute
    /// w肵Ȃ)Ƃ𐄏܂B</p>
    /// <p>ЂƂ̒ӓ_͓ߓIvNV̓RXgN^𒼐ڃC^[Zvg
    /// 邱Ƃł܂BȂ̂ŁARXgN^C^[Zvgꍇ́A
    /// RXgN^珉p̃\bhĂяo悤ɂāȀp
    /// \bhC^[ZvgĉB</p>
    /// </remarks>
    /// <example>
    /// <code lang="C#">
    /// 
    /// // IMethodInterceptor̓\bȟĂяoC^[Zvg܂B
    /// // hNXIMethodInterceptor#InvokeI[o[Ch
    /// // C^[Zvg̏ĂB܂AIMethodInterceptor#Invoke
    /// // ł͕K1AMethodInvocation#ProceedĂłB
    /// // MethodInvocation#ProceedĂ΂ƁAC^[Zvgꂽ\bh
    /// // {̏s܂B
    /// public class TestInterceptor : IMethodInterceptor
    /// {
    ///     public object Invoke(MethodInvocation invocation, out object[] outArguments)
    ///     {
    ///         Console.WriteLine("Pre");
    ///         object ret = invocation.Proceed(out outArguments);
    ///         Console.WriteLine("Post");
    ///         return ret;
    ///     }
    /// }
    ///
    /// // AttributePointcut̎wŗp鑮`܂
    /// [AttributeUsage(AttributeTargets.Method)]
    /// public class TestInterceptAttribute : Attribute
    /// {
    /// }
    ///
    /// // AXyNgWeaveNXɂAspectTarget܂B
    /// // ܂AContextBoundObjectp܂B
    /// [AspectTarget]
    /// public class TestAspectWeavedClass : ContextBoundObject
    /// {
    ///     // ̃\bhIntercept郁\bhłB
    ///     // AttributePointcut𗘗pꍇAC^[Zvg郁\bhɂ
    ///     // Kɒ`āAAttributePointcut̍쐬ɂ̑w肵܂B
    ///     // SignaturePointcut𗘗pꍇ́A\bh𐳋K\Ŏwł
    ///     // ̂ő̎w͂܂B
    ///     [TestIntercept]
    ///     public void Hello()
    ///     {
    ///         Console.WriteLine("Hello");
    ///     }
    /// }
    ///
    /// // ̃\bhsƁAR\[ɁA
    /// // "Pre","Hello","Post"̏3sA\܂
    /// public void MethodAttrInterceptTest()
    /// {
    ///     // Aspect̐
    ///     // InterceptorPointcutݒ肵܂
    ///     IAspect aspect = new AspectImpl(
    ///         new TestInterceptor(),
    ///         new MethodAttributePointcut(typeof(TestInterceptAttribute));
    ///
    ///     // Aspect̓o^
    ///     AspectWeaver.Instance().Register(aspect);
    ///
    ///     // CX^X͕̐ʂnewZqOKł
    ///     TestAspectWeavedClass wc = new TestAspectWeavedClass();
    ///
    ///     // ̃\bhTestInterceptorŃC^[Zvg܂
    ///     wc.Hello();
    /// }
    /// </code>
    /// </example>
    public class AspectWeaver
    {
        /// <summary>
        /// Aspect郁bZ[WVN
        /// </summary>
        internal class AspectWeaveMessageSink : IMessageSink
        {
            /// <summary>
            /// IɗpRXgN^Ăяoɑ΂鉞bZ[W
            /// </summary>
            /// <seealso href="http://www.mono-project.com/about/index.html">Mono Source Code</seealso>
            [Serializable]
            private class InternalConstructionResponse : ReturnMessage, IConstructionReturnMessage
            {
                /// <summary>
                /// RXgN^
                /// </summary>
                /// <param name="outArguments">RXgN^outɏo͂l̔z</param>
                /// <param name="message">RXgN^ĂяoIMethodCallMessage</param>
                public InternalConstructionResponse(object[] outArguments, IMethodCallMessage message) :
                    base(
                        null,
                        outArguments,
                        outArguments == null ? 0 : outArguments.Length,
                        message.LogicalCallContext,
                        message)
                {
                }

                /// <summary>
                /// RXgN^BRXgN^ĂяoɗOꍇ͂܂
                /// </summary>
                /// <param name="e">RXgN^ŔO</param>
                /// <param name="message">RXgN^ĂяoIMethodCallMessage</param>
                public InternalConstructionResponse(Exception e, IMethodCallMessage message) :
                    base(e, message)
                {
                }
            }

            /// <summary>
            /// bZ[WVNŏIuWFNg
            /// </summary>
            private MarshalByRefObject target;

            /// <summary>
            /// ɏIMessageSink
            /// </summary>
            private IMessageSink nextSink;

            /// <summary>
            /// 荞݃e[u
            /// </summary>
            private Hashtable interceptorMap = new Hashtable();

            /// <summary>
            /// ɏIMessageSink
            /// </summary>
            public IMessageSink NextSink
            {
                get { return nextSink; }
            }

            /// <summary>
            /// RXgN^
            /// </summary>
            /// <param name="obj">bZ[WVNŏIuWFNg</param>
            /// <param name="sink">ɏ郁bZ[WVN</param>
            public AspectWeaveMessageSink(MarshalByRefObject obj, IMessageSink sink)
            {
                target   = obj;
                nextSink = sink;
                Weave();
            }

            /// <summary>
            /// AXyNgCX^XWeave
            /// </summary>
            /// <param name="aspect">WeaveAXyNg</param>
            /// <exception cref="CanNotWeaveAspectException">
            /// ̃CX^XWeaves\ȃCX^X̏ꍇ̗O𓊂
            /// </exception>
            public void Weave(IAspect aspect)
            {
                if (!RemotingServices.IsTransparentProxy(target))
                {
                    throw new CanNotWeaveAspectException();
                }
                foreach (ConstructorInfo ci in target.GetType().GetConstructors())
                {
                    if (aspect.Pointcut.IsApplied(ci))
                    {
                        if (interceptorMap.Contains(ci))
                        {
                            ArrayList list = (ArrayList)interceptorMap[ci];
                            list.Add(aspect.Interceptor);
                        }
                        else
                        {
                            ArrayList list = new ArrayList();
                            list.Add(aspect.Interceptor);
                            interceptorMap.Add(ci, list);
                        }
                    }
                }
                foreach (MethodInfo mi in target.GetType().GetMethods())
                {
                    if (aspect.Pointcut.IsApplied(mi))
                    {
                        if (interceptorMap.Contains(mi))
                        {
                            ArrayList list = (ArrayList)interceptorMap[mi];
                            list.Add(aspect.Interceptor);
                        }
                        else
                        {
                            ArrayList list = new ArrayList();
                            list.Add(aspect.Interceptor);
                            interceptorMap.Add(mi, list);
                        }
                    }
                }
            }

            /// <summary>
            /// œnꂽCX^Xɓo^ĂAXyNgWeave
            /// </summary>
            /// <exception cref="CanNotWeaveAspectException">
            /// ̃CX^XWeaves\ȃCX^X̏ꍇ̗O𓊂
            /// </exception>
            public void Weave()
            {
                foreach (IAspect aspect in AspectWeaver.Instance().GetAspects())
                {
                    Weave(aspect);
                }
            }

            /// <summary>
            /// bZ[WVN̏()
            /// </summary>
            /// <param name="msg">\bhĂяoIMessage</param>
            /// <returns>߂lIMessage</returns>
            public IMessage SyncProcessMessage(IMessage msg)
            {
                IConstructionCallMessage ccm = msg as IConstructionCallMessage;
                if (ccm != null)
                {
                    if (interceptorMap.Contains(ccm.MethodBase))
                    {
                        ArrayList list = (ArrayList)interceptorMap[ccm.MethodBase];
                        IConstructorInterceptor[] intercepters =
                            (IConstructorInterceptor[])list.ToArray(typeof(IConstructorInterceptor));
                        IJoinPoint jointpoint = new ConstructorInvocation(target, ccm, nextSink, intercepters);
                        try
                        {
                            object[] outAuguments = null;
                            jointpoint.FirstProceed(out outAuguments);
                            return new InternalConstructionResponse(outAuguments, ccm);
                        }
                        catch (Exception e)
                        {
                            return new InternalConstructionResponse(e, ccm);
                        }
                    }
                    else
                    {
                        return nextSink.SyncProcessMessage(msg);
                    }
                }
                IMethodCallMessage mcm = msg as IMethodCallMessage;
                if (mcm != null)
                {
                    if (interceptorMap.Contains(mcm.MethodBase))
                    {
                        ArrayList list = (ArrayList)interceptorMap[mcm.MethodBase];
                        IMethodInterceptor[] intercepters =
                            (IMethodInterceptor[])list.ToArray(typeof(IMethodInterceptor));
                        IJoinPoint jointpoint = new MethodInvocation(target, mcm, nextSink, intercepters);
                        try
                        {
                            object[] outAuguments = null;
                            object returnValue = jointpoint.FirstProceed(out outAuguments);
                            if (outAuguments == null)
                            {
                                return new ReturnMessage(
                                    returnValue,
                                    null,
                                    0,
                                    mcm.LogicalCallContext,
                                    mcm);
                            }
                            else
                            {
                                return new ReturnMessage(
                                    returnValue,
                                    outAuguments,
                                    outAuguments.Length,
                                    mcm.LogicalCallContext,
                                    mcm);
                            }
                        }
                        catch (Exception e)
                        {
                            return new ReturnMessage(e, mcm);
                        }
                    }
                    else
                    {
                        return nextSink.SyncProcessMessage(msg);
                    }
                }
                return nextSink.SyncProcessMessage(msg);
            }

            /// <summary>
            /// bZ[WVN̏(񓯊)
            /// </summary>
            /// <param name="msg">\bhĂяoIMessage</param>
            /// <param name="replySink">\bh̉郁bZ[WVN</param>
            /// <returns>߂lIMessage</returns>
            public IMessageCtrl AsyncProcessMessage(IMessage msg, IMessageSink replySink)
            {
                return nextSink.AsyncProcessMessage(msg, replySink);
            }
        }

        /// <summary>
        /// SingletoñCX^X
        /// </summary>
        private static AspectWeaver instance = null;

        /// <summary>
        /// o^ĂAspect
        /// </summary>
        private ArrayList aspects = new ArrayList();

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <remarks>
        /// ̃NXSingletonȂ̂ŃRXgN^privatełB
        /// </remarks>
        private AspectWeaver()
        {
        }

        /// <summary>
        /// SingletoñCX^X擾\bh
        /// </summary>
        /// <returns>AspectWeaver̃CX^X</returns>
        public static AspectWeaver Instance()
        {
            if (instance == null)
            {
                instance = new AspectWeaver();
            }
            return instance;
        }

        /// <summary>
        /// Aspecto^
        /// </summary>
        /// <param name="aspect">o^Aspect</param>
        public void Register(IAspect aspect)
        {
            aspects.Add(aspect);
        }

        /// <summary>
        /// o^ꂽAXyNg̎擾
        /// </summary>
        /// <returns>o^ꂽAXyNg</returns>
        public IAspect[] GetAspects()
        {
            return (IAspect[])aspects.ToArray(typeof(IAspect));
        }
    }
}
