using System;
using System.Collections;
using System.Reflection;
using Kodama.Function.Functor;
using Kodama.Function.Functor.Bind;
using Kodama.Function.Functor.Member;
using Kodama.DependencyInjection.Container;
using Kodama.DependencyInjection.Marker;

namespace Kodama.DependencyInjection.Component
{
    /// <summary>
    /// DependencyInjectionReiɓo^ĂR|[lg
    /// </summary>
    /// <remarks>
    /// ɂR|[lg̃CX^XDependencyInjectionRei
    /// o^̂Ɏgp܂B
    /// ̃R|[lgœo^ĂR|[lǵA
    /// IComponentContainer#GetComponentɏɓCX^XԂB
    /// </remarks>
    /// <seealso cref="Kodama.DependencyInjection.Container.ComponentContainerImpl"/>
    public class OuterComponentEntry : IComponentEntry
    {
        /// <summary>
        /// o^ĂR|[lg̃CX^X
        /// </summary>
        private object componentInstance;

        /// <summary>
        /// o^ĂR|[lǧ^
        /// </summary>
        private Type componentType;

        /// <summary>
        /// o^ĂR|[lg̖O
        /// </summary>
        private string componentName;

        /// <summary>
        /// ɈˑĂ邩ǂ
        /// </summary>
        private bool isSolvedDependency;

        /// <summary>
        /// ˑ𒍓邽߂̈oChς݂̊֐IuWFNg
        /// </summary>
        private ArrayList injectionFactors = new ArrayList();

        /// <summary>
        /// R|[lg邽߂̈oChς݂̊֐IuWFNg
        /// </summary>
        private ArrayList initializationFactors = new ArrayList();

        /// <summary>
        /// o^ĂR|[lǧ^
        /// </summary>
        public Type ComponentType
        {
            get { return componentType; }
        }

        /// <summary>
        /// o^ĂR|[lg̖O
        /// </summary>
        public string ComponentName
        {
            get { return componentName; }
        }

        /// <summary>
        /// ˑ𒍓邽߂̃RXgN^̈oCht@N^
        /// </summary>
        /// <exception cref="NotSupportedException">̃\bh̓T|[gĂȂ̂ŕK̗O𓊂</exception>
        public BindFunctor InjectionConstructor
        {
            set { throw new NotSupportedException(); }
        }

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="container">R|[lgo^Rei</param>
        /// <param name="instance">o^R|[lg̃CX^X</param>
        public OuterComponentEntry(IComponentContainer container, object instance)
        {
            componentType      = instance.GetType();
            componentName      = instance.GetType().FullName;
            componentInstance  = instance;
            isSolvedDependency = false;

            foreach (MethodInfo mi in componentType.GetMethods())
            {
                if (Attribute.IsDefined(mi, typeof(InjectionPointAttribute)))
                {
                    ArrayList arguments = new ArrayList();
                    arguments.Add(new NotBoundArgument(0));
                    foreach (ParameterInfo param in mi.GetParameters())
                    {
                        if (Attribute.IsDefined(param, typeof(ExplicitComponentAttribute)))
                        {
                            ExplicitComponentAttribute eca =
                                (ExplicitComponentAttribute)Attribute.GetCustomAttribute
                                (param, typeof(ExplicitComponentAttribute));
                            arguments.Add(eca.CreateProvider(container));
                        }
                        else
                        {
                            arguments.Add(new TypedArgumentComponentProvider(container, param.ParameterType));
                        }    
                    }
                    injectionFactors.Add(new BindFunctor(new MemberFunctor(mi), arguments.ToArray()));
                }
            }

            foreach (MethodInfo mi in componentType.GetMethods())
            {
                if (Attribute.IsDefined(mi, typeof(InitializationPointAttribute)))
                {
                    initializationFactors.Add(new MemberFunctor(mi));
                }
            }
        }

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="container">R|[lgo^Rei</param>
        /// <param name="instance">o^R|[lg̃CX^X</param>
        /// <param name="name">o^R|[lg̖O</param>
        public OuterComponentEntry(IComponentContainer container, object instance, string name)
        {
            componentType      = instance.GetType();
            componentName      = name;
            componentInstance  = instance;
            isSolvedDependency = false;

            foreach (MethodInfo mi in componentType.GetMethods())
            {
                if (Attribute.IsDefined(mi, typeof(InjectionPointAttribute)))
                {
                    ArrayList arguments = new ArrayList();
                    arguments.Add(new NotBoundArgument(0));
                    foreach (ParameterInfo param in mi.GetParameters())
                    {
                        arguments.Add(new TypedArgumentComponentProvider(container, param.ParameterType));
                    }
                    injectionFactors.Add(new BindFunctor(new MemberFunctor(mi), arguments.ToArray()));
                }
            }

            foreach (MethodInfo mi in componentType.GetMethods())
            {
                if (Attribute.IsDefined(mi, typeof(InitializationPointAttribute)))
                {
                    initializationFactors.Add(new MemberFunctor(mi));
                }
            }
        }

        /// <summary>
        /// ˑ𒍓邽߂̈oChς݂̊֐IuWFNgǉ
        /// </summary>
        /// <param name="functor">ǉ֐IuWFNg</param>
        public void AddInjectionFanctor(BindFunctor functor)
        {
            injectionFactors.Add(functor);
        }

        /// <summary>
        /// R|[lg邽߂̈oChς݂̊֐IuWFNgǉ
        /// </summary>
        /// <param name="functor">ǉ֐IuWFNg</param>
        public void AddInitializationFactor(IFunctor functor)
        {
            initializationFactors.Add(functor);
        }

        /// <summary>
        /// R|[lgˑĂR|[lg̓o^Ԃ
        /// </summary>
        /// <returns>R|[lgˑĂR|[lg̓o^</returns>
        public IComponentEntry[] GetDependencies()
        {
            ArrayList list = new ArrayList();
            foreach (BindFunctor functor in injectionFactors)
            {
                foreach (object arg in functor.GetBoundArguments())
                {
                    IArgumentComponentProvider provider = arg as IArgumentComponentProvider;
                    if (provider != null)
                    {
                        list.Add(provider.ComponentEntry);
                    }
                }
            }
            return (IComponentEntry[])list.ToArray(typeof(IComponentEntry));
        }

        /// <summary>
        /// R|[lg̃CX^X擾
        /// </summary>
        /// <returns>R|[lg̃CX^X</returns>
        /// <remarks>
        /// ̃\bhŐVCX^XԂ̃CX^XԂ
        /// őI܂B
        /// </remarks>
        public object GetInstance()
        {
            if (!isSolvedDependency)
            {
                foreach (IFunctor functor in injectionFactors)
                {
                    functor.Invoke(componentInstance);
                }

                foreach (IFunctor functor in initializationFactors)
                {
                    functor.Invoke(componentInstance);
                }

                isSolvedDependency = true;
            }

            return componentInstance;
        }

        /// <summary>
        /// R|[lg̃CX^Xj
        /// </summary>
        /// <remarks>
        /// jR|[lgIDisposableĂ邱ƁB
        /// </remarks>
        public void Discard()
        {
/*            IDisposable disposable = componentInstance as IDisposable;
            if (disposable != null)
            {
                disposable.Dispose();
                componentInstance = null;
                isSolvedDependency = false;
            }*/
        }
    }
}
