using System;
using System.Collections;
using System.Reflection;
using System.IO;

namespace Kodama.DependencyInjection.Loader
{
    /// <summary>
    /// w肳ꂽpX̃AZu^[h܂
    /// </summary>
    public class TypeLoader : IDisposable
    {
        /// <summary>
        /// q[_
        /// </summary>
        private ArrayList children = new ArrayList();

        /// <summary>
        /// ^[hAZu
        /// </summary>
        private ArrayList assemblies = new ArrayList();

        /// <summary>
        /// ftHgRXgN^
        /// </summary>
        public TypeLoader()
        {
            // Ȃ
        }

        /// <summary>
        /// RXgN^
        /// </summary>
        /// <param name="parent">e[_</param>
        public TypeLoader(TypeLoader parent)
        {
            parent.AddChild(this);
        }

        /// <summary>
        /// q[_ǉ
        /// </summary>
        /// <param name="child">ǉq[_</param>
        public void AddChild(TypeLoader child)
        {
            children.Add(child);
        }

        /// <summary>
        /// ^ǂݏoAZuǉ
        /// </summary>
        /// <param name="filename">^ǂݏoAZũt@C</param>
        public void AddAssemblyFile(string filename)
        {
            assemblies.Add(Assembly.LoadFile(filename));
        }

        /// <summary>
        /// ^ǂݏoAZuǉ
        /// </summary>
        /// <param name="folder">^ǂݏoAZu܂܂tH_</param>
        public void AddAssemblyFolder(string folder)
        {
            foreach (string name in Directory.GetFiles(folder, "*.dll"))
            {
                assemblies.Add(Assembly.LoadFile(Path.Combine(folder, name)));
            }
        }

        /// <summary>
        /// w肳ꂽǑ^AZu烍[h܂
        /// </summary>
        /// <param name="fullTypeName">[h^̖O</param>
        /// <returns>[hꂽ^</returns>
        /// <exception cref="TypeNotFoundException">
        /// w肳ꂽǑ^݂ȂꍇɔO
        /// </exception>
        public Type LoadType(string fullTypeName)
        {
            foreach (Assembly assembly in assemblies)
            {
                Type type = assembly.GetType(fullTypeName);
                if (type != null)
                {
                    return type;
                }
            }
            foreach (TypeLoader child in children)
            {
                try
                {
                    return child.LoadType(fullTypeName);
                }
                catch (TypeNotFoundException)
                {
                }
            }
            throw new TypeNotFoundException();
        }

        /// <summary>
        /// [h\[Xj
        /// </summary>
        public void Dispose()
        {
            assemblies.Clear();

            foreach (TypeLoader child in children)
            {
                child.Dispose();
            }
        }
    }
}
